/**
 * This class desribes objects that are used to track
 * the player's scores in a game of Pong.  Each PongScore
 * object will keep the score for a single player.
 */
public class PongScore {
    
    private int score;

    /**
     * Construct a new PongScore object with an initial 
     * score of zero points.
     */
    public PongScore() {
        score = 0;
    }

    /**
     * Return the current score of this PongScore object.
     *
     * @return the score.
     */
    public int getScore() {
        return score;
    }

    /**
     * Increase the current score of this PongScore object
     * by points.
     *
     * @param points the number of points to add to the
     *               score.
     */
    public void scorePoints(int points) {
	score = score + points;
    }
}


